/*	
	streamripper-plugin 0.1		
	Copyright (C) 2008 by lokster 
	lokiisyourmaster@gmail.com
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or   
	(at your option) any later version.                                 
	                                                                    
	This program is distributed in the hope that it will be useful,     
	but WITHOUT ANY WARRANTY; without even the implied warranty of      
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
	GNU General Public License for more details.                        
	                                                                    
	You should have received a copy of the GNU General Public License   
	along with this program; if not, write to the                       
	Free Software Foundation, Inc.,                                     
	59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
*/   
#include "config.h"

#include <glib.h>
#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <signal.h>
#include <unistd.h>
#include <stdio.h>

#include <string.h>

#include <audacious/plugin.h>
#include <audacious/ui_preferences.h>
#include <audacious/auddrct.h>
#include <audacious/i18n.h>
#include <audacious/hook.h>
#include <audacious/ui_plugin_menu.h>
#include <audacious/playlist.h>
#include <audacious/strings.h>
#include <audacious/main.h>

static void init(void);
static void cleanup(void);
static void configure(void);

static GtkWidget *conf_dialog = NULL;
//~ static GtkWidget *entry = NULL;

GeneralPlugin sr_gp =
{
	.description = "StreamRipper " PACKAGE_VERSION,
	.init = init,
	.configure = configure,
	.cleanup = cleanup,
};

GeneralPlugin *streamripper_gplist[] = { &sr_gp, NULL };
SIMPLE_GENERAL_PLUGIN(streamripper, streamripper_gplist);

static void cleanup(void)
{
	signal(SIGCHLD, SIG_DFL);
}

static void conf_ok_cb(GtkButton * button, gpointer data)
{
	mcs_handle_t *db;
	db = aud_cfg_db_open();
	aud_cfg_db_set_string(db, "streamripper", "path", gtk_entry_get_text(GTK_ENTRY((GtkWidget *)data)));
	aud_cfg_db_close(db);
	gtk_widget_destroy(conf_dialog);
	
}


static void conf_cancel_cb(GtkButton * button, gpointer data)
{
	gtk_widget_destroy(conf_dialog);
}

static void configure(void)
{
	GtkWidget *hbox, *label, *button, *bbox, *entry;
	gchar *path;
	mcs_handle_t *db;
	
	if (conf_dialog != NULL)
		return;
		

	db = aud_cfg_db_open();
	if (!aud_cfg_db_get_string(db, "streamripper", "path", &path))
		path = "~/";
	aud_cfg_db_close(db);
	
	conf_dialog = gtk_dialog_new();
	g_signal_connect(GTK_OBJECT(conf_dialog), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed), &conf_dialog);
	gtk_window_set_title(GTK_WINDOW(conf_dialog), _("Configure streamripper-plugin"));

	label = gtk_label_new(_("Save files in:"));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(conf_dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);

	entry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(conf_dialog)->vbox), entry, TRUE, TRUE, 0);
	gtk_entry_set_text(GTK_ENTRY(entry),path);
	gtk_widget_set_usize(entry,300,-1);
	gtk_widget_show(entry);
	
	
	hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(conf_dialog)->vbox), hbox, TRUE, TRUE, 10);
	gtk_widget_show(hbox);
	
	bbox = gtk_hbutton_box_new();
	gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(bbox), 5);
	gtk_box_pack_start(GTK_BOX((GTK_DIALOG(conf_dialog)->action_area)), bbox, TRUE, TRUE, 0);

	button = gtk_button_new_with_label(_("Ok"));
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(bbox), button, TRUE, TRUE, 0);
	gtk_widget_grab_default(button);
	g_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(conf_ok_cb), entry);
	//~ g_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(conf_ok_cb), g_strdup(gtk_entry_get_text(entry)));
	gtk_widget_show(button);

	button = gtk_button_new_with_label(_("Cancel"));
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(bbox), button, TRUE, TRUE, 0);
	g_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(conf_cancel_cb), NULL);
			   //&GTK_ENTRY(entry)); //&GTK_ENTRY(entry)->text &gtk_entry_get_text()
	gtk_widget_show(button);

	//~ button = gtk_button_new_with_label(_("Apply"));
	//~ GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
	//~ gtk_box_pack_start(GTK_BOX(bbox), button, TRUE, TRUE, 0);
	//~ g_signal_connect(GTK_OBJECT(button), "clicked",
			   //~ GTK_SIGNAL_FUNC(conf_apply_cb),
			   //~ &GTK_ENTRY(entry)->value);
	//~ gtk_widget_show(button);

	gtk_widget_show(bbox);

	gtk_widget_show(conf_dialog);
}


static void run_streamripper(void)
{

	gchar *path;
	mcs_handle_t *db;	
		
	db = aud_cfg_db_open();
	if (!aud_cfg_db_get_string(db, "streamripper", "path", &path))
		path = "~/";
	aud_cfg_db_close(db);
	
	char *str1 = "xterm -e streamripper \"`audtool current-song-filename`\" -r -i -d ";
	char *str3;
	str3 = (char *)calloc(strlen(str1) + strlen(path) + 1, sizeof(char));
	strcat(str3, str1);
	strcat(str3, path);

	char *argv[4] = {"/bin/sh", "-c", (char *)str3, NULL};
	
	int i;

	if (fork() == 0)
	{
		for (i = 3; i < 255; i++)
			close(i);
		execv("/bin/sh", argv);
	}
	free(str3);
}

static void run_streamripper1(void)
{


	gchar *path;
	mcs_handle_t *db;	
		
	db = aud_cfg_db_open();
	if (!aud_cfg_db_get_string(db, "streamripper", "path", &path))
		path = "~/";
	aud_cfg_db_close(db);
	
	char *str1 = "xterm -e streamripper \"`audtool current-song-filename`\" -r -i -d ";
	char *str3;
	str3 = (char *)calloc(strlen(str1) + strlen(path) + 1, sizeof(char));
	strcat(str3, str1);
	strcat(str3, path);

	
	char *argv[4] = {"/bin/sh", "-c", (char *)str3, NULL};
	char *argv1[4] = {"/bin/sh", "-c", "audacious http://localhost:8000", NULL};

	int i;

	if (fork() == 0)
	{
		for (i = 3; i < 255; i++)
			close(i);
		execv("/bin/sh", argv);
	}
	
	if (fork() == 0)
	{
		for (i = 3; i < 255; i++)
			close(i);
		execv("/bin/sh", argv1);
	}
}

static void init(void)
{
	gchar *menu_item_text;
	static GtkWidget *main_menu_item;
	gchar *menu_item_text1;
	static GtkWidget *main_menu_item1;

	menu_item_text = _("Rip with streamripper");
	main_menu_item = gtk_image_menu_item_new_with_label(menu_item_text);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(main_menu_item), gtk_image_new_from_stock(GTK_STOCK_SAVE, GTK_ICON_SIZE_MENU));
	gtk_widget_show(main_menu_item);
	audacious_menu_plugin_item_add(AUDACIOUS_MENU_MAIN, main_menu_item);
	g_signal_connect(G_OBJECT(main_menu_item), "activate", G_CALLBACK(run_streamripper), NULL);
	
	menu_item_text1 = _("Rip with streamripper and play relay stream");
	main_menu_item1 = gtk_image_menu_item_new_with_label(menu_item_text1);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(main_menu_item1), gtk_image_new_from_stock(GTK_STOCK_SAVE, GTK_ICON_SIZE_MENU));
	gtk_widget_show(main_menu_item1);
	audacious_menu_plugin_item_add(AUDACIOUS_MENU_MAIN, main_menu_item1);
	g_signal_connect(G_OBJECT(main_menu_item1), "activate", G_CALLBACK(run_streamripper1), NULL);
}
